VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   6435
   ClientLeft      =   60
   ClientTop       =   405
   ClientWidth     =   9945
   LinkTopic       =   "Form1"
   ScaleHeight     =   6435
   ScaleWidth      =   9945
   StartUpPosition =   3  'Windows Default
   Begin Proyecto1.ucCalendar ucCalendar1 
      Height          =   5295
      Left            =   480
      TabIndex        =   0
      Top             =   600
      Width           =   8535
      _ExtentX        =   17171
      _ExtentY        =   9975
      BeginProperty Font {0BE35203-8F91-11CE-9DE3-00AA004BB851} 
         Name            =   "Segoe UI"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   -2147483643
      BackColor       =   -2147483642
      HeaderColor     =   5395026
      LinesColor      =   5395026
      SelectionColor  =   4950888
      DropDownColor   =   5395026
      ViewMode        =   2
      FirstDayOfWeek  =   2
   End
   Begin VB.Label Label1 
      Caption         =   "Label1"
      Height          =   1815
      Left            =   4800
      TabIndex        =   1
      Top             =   2880
      Width           =   2175
   End
   Begin VB.Menu MnuPopUp 
      Caption         =   "MnuPopUp"
      Visible         =   0   'False
      Begin VB.Menu MnuAdd 
         Caption         =   "Add new"
      End
      Begin VB.Menu MnuDelete 
         Caption         =   "Delete"
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Private Declare Function GetTimeZoneInformation Lib "kernel32" (lpTimeZoneInformation As TIME_ZONE_INFORMATION) As Long
Private Type TIME_ZONE_INFORMATION
    Bias As Long
    StandardName(32) As Integer
    StandardDate(7) As Integer 'SYSTEMTIME
    StandardBias As Long
    DaylightName(32) As Integer
    DaylightDate(7) As Integer 'SYSTEMTIME
    DaylightBias As Long
End Type


Public dbcnn        As SQLiteConnection
Public ColEvents    As New Collection
Private iTimeDiff   As Integer

Private Sub Form_Load()
    Dim lKey As Long
    Dim cEvent As ClsEventPlus
    
    Dim tz As TIME_ZONE_INFORMATION
    Call GetTimeZoneInformation(tz)
    iTimeDiff = tz.Bias
    
    Set dbcnn = SQLite.Connection(App.Path & "\BD.db")
    
    With ucCalendar1
        .Redraw = False
        .SetStrLanguage "Ao", "Mes", "Semana", "Da", "Hoy", "Comienza", "Finaliza", "Todo el da"

        With dbcnn.Query("SELECT * FROM Events;")
            Do While .Step = SQLITE_ROW
                lKey = ucCalendar1.AddEvents(.Value("Subject"), GetDateFromUnixDate(.Value("StartTime")), GetDateFromUnixDate(.Value("EndTime")), .Value("Category"), .Value("AllDay"), .Value("Comment"), , .Value("IsSerie"), .Value("Notify"), .Value("Private"), .Value("ShowTimeAs"))

                Set cEvent = New ClsEventPlus
                cEvent.ID = .Value("ID")
                cEvent.NotifyIndex = .Value("NotifyMinutes")
                cEvent.Location = .Value("Location")
                ColEvents.Add cEvent, CStr(lKey)
            Loop
        End With
    
       .Redraw = True
    End With

End Sub

Public Function GetDateFromUnixDate(ByVal sUnixDate As String) As Date
    Dim d As Date, N As Double
    
    N = Left(sUnixDate, 11) / 10
    d = DateSerial(1601, 1, 1)
    
    Dim i As Long
    For i = 1 To 10
        d = DateAdd("S", N, d)
    Next
    If Len(CStr(N)) > Len(CStr(CLng(N))) Then
        N = Mid(N, Len(CStr(CLng(N))) + 2)
        d = DateAdd("S", N, d)
    End If
    
    GetDateFromUnixDate = DateAdd("n", -iTimeDiff, d)

End Function

Public Function ConvertToUnixTime(ByVal DateTime As Date) As String
    DateTime = DateAdd("n", iTimeDiff, DateTime)
    ConvertToUnixTime = CStr(DateDiff("S", CDate("1/1/1601"), DateTime) * 10000) & "00"
End Function

Private Function BoolToInt(Value As Boolean) As Integer
        If Value Then BoolToInt = 1
End Function

Private Function Random(Min, max) As Long
    Random = CInt((max - Min + 1) * Rnd + Min)
End Function

Private Sub Form_Resize()
    ucCalendar1.Move 0, 0, Me.ScaleWidth, Me.ScaleHeight
End Sub

Private Sub ucCalendar1_DateBackColor(CellDate As Date, Color As stdole.OLE_COLOR, eHatchStyle As HatchStyle)
    If Weekday(CellDate) = vbSunday Or Weekday(CellDate) = vbSaturday Then
        Color = &H5A5A5A
        If Weekday(CellDate) = vbSunday And VBA.TimeValue(CellDate) <= CDate("12:00") Then
            eHatchStyle = 2
        End If
    
    End If
    
'    If ucCalendar1.ViewMode = vm_Week Then
'        If VBA.TimeValue(CellDate) > CDate("00:00") And VBA.TimeValue(CellDate) <= CDate("08:00") Then
'            Color = &HF7F7F7
'        End If
'    Else
'        If CellDate = CDate("28/4/2022") Then
'            Color = &HCCCCCC
'            eHatchStyle = 2
'        End If
'    End If
End Sub

Private Sub ucCalendar1_EventClick(ByVal EventKey As Long)
    Dim Subject As String, StartDate As Date, EndDate As Date, Color As Long, AllDayEvent As Boolean, body As String
    Dim IsSerie As Boolean, IsPrivate As Boolean, bNotify As Boolean, EventShowAs As eEventShowAs
    'ucCalendar1.RemoveEvent EventKey
    
    
    If ucCalendar1.GetEventData(EventKey, Subject, StartDate, EndDate, Color, AllDayEvent, body, , IsSerie, bNotify, IsPrivate, EventShowAs) Then
        With Form2
            .TxtSubject = Subject
            .DTPStartDate = DateValue(StartDate)
            .DTPStartTime = StartDate
            .DTPEndDate = DateValue(EndDate)
            .DTPEndTime = EndDate
            .ChkAllDay.Value = IIf(AllDayEvent, 1, 0)
            .EventKey = EventKey
            .TxtBody = body
            .PicColor.BackColor = Color
            .ChkIsSerie.Value = IIf(IsSerie, 1, 0)
            .ChkPrivate.Value = IIf(IsPrivate, 1, 0)
            .ChkNotify.Value = IIf(bNotify, 1, 0)
            .CboNotify.ListIndex = ColEvents(CStr(EventKey)).NotifyIndex
            .TxtLocation = ColEvents(CStr(EventKey)).Location
            .ImageCombo1.ComboItems.Item(EventShowAs + 1).Selected = True
        End With
        Form2.Show vbModal, Me
    End If
    'ucCalendar1.Refresh

End Sub

Private Sub ucCalendar1_PreEventChangeDate(ByVal EventKey As Long, ByVal StartDate As Date, ByVal EndDate As Date, Cancel As Boolean)
   ' Debug.Print StartDate, EndDate
'    If DateValue(StartDate) <= CDate("28/4/2022") And DateValue(EndDate) >= CDate("28/4/2022") Then
'        Cancel = True
'    End If
'
    If Weekday(StartDate) = vbSunday And VBA.TimeValue(StartDate) < CDate("12:00") Then
        Cancel = True
    End If
End Sub


Private Sub ucCalendar1_DragNewEvent(ByVal EventKey As Long, ByVal SourceKey As Long)
        Dim Subject As String, StartDate As Date, EndDate As Date, Color As Long, AllDayEvent As Boolean, body As String
        Dim IsSerie As Boolean, IsPrivate As Boolean, bNotify As Boolean, EventShowAs As eEventShowAs
        Dim tmp As String
        Dim cEvent As ClsEventPlus
        ucCalendar1.GetEventData EventKey, Subject, StartDate, EndDate, Color, _
                    AllDayEvent, body, , IsSerie, IsPrivate, bNotify, EventShowAs

        tmp = "INSERT INTO Events (StartTime, EndTime, Subject, Location, AllDay, Comment, Category, ShowTimeAs, Private, Notify, IsSerie, SerieKey, NotifyMinutes) VALUES('" & _
        ConvertToUnixTime(StartDate) & "','" & ConvertToUnixTime(EndDate) & "','" & Subject & "','" & _
        ColEvents(CStr(SourceKey)).Location & "','" & BoolToInt(AllDayEvent) & "','" & body & "','" & _
        Color & "','" & EventShowAs & "','" & BoolToInt(IsPrivate) & "','" & _
        BoolToInt(bNotify) & "','" & BoolToInt(IsSerie) & "','" & "1" & "','" & ColEvents(CStr(SourceKey)).NotifyIndex & "');"
                
        If dbcnn.Execute(tmp) <> SQLITE_OK Then dbcnn.ShowError: Exit Sub
 
        Set cEvent = New ClsEventPlus
        cEvent.NotifyIndex = ColEvents(CStr(SourceKey)).NotifyIndex
        cEvent.Location = ColEvents(CStr(SourceKey)).Location
        cEvent.ID = dbcnn.LastInsertID
        ColEvents.Add cEvent, CStr(EventKey)
        
End Sub

Private Sub ucCalendar1_DropDownViewMore(CellDate As Date, CancelViewModeDay As Boolean)
'    Dim Subject As String, StartDate As Date, EndDate As Date, Color As Long, AllDayEvent As Boolean, body As String
'    Dim IsSerie As Boolean, IsPrivate As Boolean, bNotify As Boolean, EventShowAs As eEventShowAs
'    List1.Clear
'    List1.Move Me.ScaleWidth / 2 - List1.Width / 2, Me.ScaleHeight / 2 - List1.Height / 2
'    List1.Visible = True
'    Dim cCol As Collection
'    Dim i As Long
'    CancelViewModeDay = True
'    Set cCol = ucCalendar1.GetEventsFromDay(CellDate)
'    For i = 1 To cCol.Count
'        If ucCalendar1.GetEventData(cCol.Item(i), Subject, StartDate, EndDate, Color, AllDayEvent, body, , IsSerie, bNotify, IsPrivate, EventShowAs) Then
'            List1.AddItem Subject
'        End If
'    Next
End Sub


Private Sub ucCalendar1_EventChangeDate(ByVal EventKey As Long, ByVal StartDate As Date, ByVal EndDate As Date, ByVal AllDay As Boolean)
    'Debug.Print EventKey, StartDate, EndDate
    Dim tmp As String
    tmp = "UPDATE Events SET StartTime ='" & ConvertToUnixTime(StartDate) & "',  EndTime ='" & ConvertToUnixTime(EndDate) & _
    "', AllDay ='" & BoolToInt(AllDay) & "' WHERE id='" & ColEvents(CStr(EventKey)).ID & "';"
    If dbcnn.Execute(tmp) <> SQLITE_OK Then dbcnn.ShowError: Exit Sub
End Sub


Private Sub ucCalendar1_EventMouseEnter(ByVal EventKey As Long)
    'Debug.Print "EventMouseEnter", EventKey
End Sub

Private Sub ucCalendar1_EventMouseLeave(ByVal EventKey As Long)
    'Debug.Print "EventMouseLeave", EventKey
End Sub

Private Sub ucCalendar1_MouseUp(Button As Integer, Shift As Integer, X As Single, Y As Single)
    Dim StartDate As Date, EndDate As Date
   
    If ucCalendar1.GetSelectionRangeDate(StartDate, EndDate) = False Then Exit Sub
    
    If Button = vbRightButton Then
        With Form2
            .TxtSubject = ""
            .DTPStartDate = DateValue(StartDate)
            .DTPStartTime = StartDate
            .DTPEndDate = DateValue(EndDate)
            .DTPEndTime = EndDate
            If ucCalendar1.ViewMode = vm_Month Or (StartDate = EndDate) Then
                .ChkAllDay.Value = 1
            End If
            .EventKey = 0
        End With
        Form2.Show vbModal, Me
    End If
End Sub

Private Sub ucCalendar1_PreDateChange(NewDate As Date, Cancel As Boolean)
'    With ucCalendar1
'        .Redraw = False
'        .Clear
'        .AddEvents "Dinamico", NewDate, NewDate + 1, &HBFA7E3, False
'        .Redraw = True
'    End With
End Sub


